Index: trunk/src/VBox/Additions/x11/VBoxClient/wayland-helper-dcp.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/wayland-helper-dcp.cpp	(revision 101882)
+++ trunk/src/VBox/Additions/x11/VBoxClient/wayland-helper-dcp.cpp	(revision 101883)
@@ -352,6 +352,6 @@
  * @returns IPRT status code.
  * @param   fd                  A file descriptor to write data to.
- * @param   ppvBuf              Data buffer.
- * @param   pcbBuf              Size of data buffer.
+ * @param   pvBuf               Data buffer.
+ * @param   cbBuf               Size of data buffer.
  */
 RTDECL(int) vbcl_wayland_hlp_dcp_write_wl_fd(int fd, void *pvBuf, size_t cbBuf)
@@ -455,5 +455,4 @@
  * Release session resources.
  *
- * @returns IPRT status code.
  * @param   pSession        Session data.
  */
@@ -482,5 +481,4 @@
  * Initialize session.
  *
- * @returns IPRT status code.
  * @param   pSession        Session data.
  */
@@ -498,5 +496,4 @@
  * Reset previously initialized session.
  *
- * @returns IPRT status code.
  * @param   pSession        Session data.
  */
@@ -505,31 +502,4 @@
     vbcl_wayland_hlp_dcp_session_release(pSession);
     vbcl_wayland_hlp_dcp_session_init(pSession);
-#if 0
-    void *pvData;
-
-    if (!RTListIsEmpty(&pSession->clip.mimeTypesList.Node))
-    {
-        vbox_wl_dcp_mime_t *pEntry, *pNextEntry;
-
-        RTListForEachSafe(&pSession->clip.mimeTypesList.Node, pEntry, pNextEntry, vbox_wl_dcp_mime_t, Node)
-        {
-            RTListNodeRemove(&pEntry->Node);
-            RTStrFree(pEntry->pszMimeType);
-            RTMemFree(pEntry);
-        }
-    }
-
-    pvData = (void *)pSession->clip.pvClipboardBuf.reset();
-    if (RT_VALID_PTR(pvData))
-        RTMemFree(pvData);
-
-
-    RTListInit(&pSession->clip.mimeTypesList.Node);
-
-    pSession->clip.fFmts.init(VBOX_SHCL_FMT_NONE, VBCL_WAYLAND_VALUE_WAIT_TIMEOUT_MS);
-    pSession->clip.uFmt.init(VBOX_SHCL_FMT_NONE, VBCL_WAYLAND_VALUE_WAIT_TIMEOUT_MS);
-    pSession->clip.pvClipboardBuf.init(0, VBCL_WAYLAND_DATA_WAIT_TIMEOUT_MS);
-    pSession->clip.cbClipboardBuf.init(0, VBCL_WAYLAND_DATA_WAIT_TIMEOUT_MS);
-#endif
 }
 
@@ -771,4 +741,5 @@
  * @param   pCtx            DCP context data.
  * @param   pOffer          Data offer object.
+ * @param   uFmt            Clipboard format in VBox representation.
  * @param   pszMimeType     Requested mime-type in string representation.
  */
@@ -976,7 +947,7 @@
  */
 static void vbcl_wayland_hlp_dcp_data_device_finished(
-    void *data, struct zwlr_data_control_device_v1 *pDevice)
-{
-    RT_NOREF(data);
+    void *pvUser, struct zwlr_data_control_device_v1 *pDevice)
+{
+    RT_NOREF(pvUser);
 
     VBCL_LOG_CALLBACK;
@@ -1025,5 +996,5 @@
  *
  * @param pvUser            VBox private data.
- * @param pSourceSource     Wayland Data Control Source object.
+ * @param pDataSource,      Wayland Data Control Source object.
  * @param sMimeType         A mime-type of requested data.
  * @param fd                A file descriptor to write clipboard content into.
Index: trunk/src/VBox/Additions/x11/VBoxClient/wayland-helper-gtk.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/wayland-helper-gtk.cpp	(revision 101882)
+++ trunk/src/VBox/Additions/x11/VBoxClient/wayland-helper-gtk.cpp	(revision 101883)
@@ -66,5 +66,5 @@
 /**
  * A set of objects required to handle clipboard sharing over
- * and drag-n-drop using Gtk library.. */
+ * and drag-n-drop using Gtk library. */
 typedef struct
 {
Index: trunk/src/VBox/Additions/x11/VBoxClient/wayland-helper-ipc.h
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/wayland-helper-ipc.h	(revision 101882)
+++ trunk/src/VBox/Additions/x11/VBoxClient/wayland-helper-ipc.h	(revision 101883)
@@ -294,6 +294,6 @@
                      *
                      * @returns IPRT status code.
-                     * @param   uSessionId  IPC session ID.
-                     * @param   uSessionId  IPC connection handle.
+                     * @param   uSessionId      IPC session ID.
+                     * @param   hIpcSession     IPC connection handle.
                      */
                     int send_formats(uint32_t uSessionId, RTLOCALIPCSESSION hIpcSession);
@@ -303,6 +303,6 @@
                      *
                      * @returns IPRT status code.
-                     * @param   uSessionId  IPC session ID.
-                     * @param   uSessionId  IPC connection handle.
+                     * @param   uSessionId      IPC session ID.
+                     * @param   hIpcSession     IPC connection handle.
                      */
                     int recv_formats(uint32_t uSessionId, RTLOCALIPCSESSION hIpcSession);
@@ -312,16 +312,15 @@
                      *
                      * @returns IPRT status code.
-                     * @param   uSessionId  IPC session ID.
-                     * @param   uSessionId  IPC connection handle.
+                     * @param   uSessionId      IPC session ID.
+                     * @param   hIpcSession     IPC connection handle.
                      */
                     int send_format(uint32_t uSessionId, RTLOCALIPCSESSION hIpcSession);
 
-
                     /**
                      * Receive requested clipboard format over IPC.
                      *
                      * @returns IPRT status code.
-                     * @param   uSessionId  IPC session ID.
-                     * @param   uSessionId  IPC connection handle.
+                     * @param   uSessionId      IPC session ID.
+                     * @param   hIpcSession     IPC connection handle.
                      */
                     int recv_format(uint32_t uSessionId, RTLOCALIPCSESSION hIpcSession);
@@ -331,6 +330,6 @@
                      *
                      * @returns IPRT status code.
-                     * @param   uSessionId  IPC session ID.
-                     * @param   uSessionId  IPC connection handle.
+                     * @param   uSessionId      IPC session ID.
+                     * @param   hIpcSession     IPC connection handle.
                      */
                     int send_data(uint32_t uSessionId, RTLOCALIPCSESSION hIpcSession);
@@ -340,6 +339,6 @@
                      *
                      * @returns IPRT status code.
-                     * @param   uSessionId  IPC session ID.
-                     * @param   uSessionId  IPC connection handle.
+                     * @param   uSessionId      IPC session ID.
+                     * @param   hIpcSession     IPC connection handle.
                      */
                     int recv_data(uint32_t uSessionId, RTLOCALIPCSESSION hIpcSession);
@@ -414,5 +413,5 @@
  * This function should be used by both IPC server and client code
  * in order to connect one to another. Output string will be in
- * format: GtkHlpIpcServer-<active tty>-<user name>.
+ * format: GtkHlpIpcServer-&lt;active tty&gt;-&lt;user name&gt;.
  *
  * @returns     IPRT status code.