Index: trunk/src/libs/xpcom18a4/Config.kmk
===================================================================
--- trunk/src/libs/xpcom18a4/Config.kmk	(revision 101919)
+++ trunk/src/libs/xpcom18a4/Config.kmk	(revision 101920)
@@ -377,7 +377,4 @@
 	xpcom/base/nsITraceRefcnt.idl \
 	xpcom/base/nsIWeakReference.idl \
-	xpcom/base/nsIConsoleMessage.idl \
-	xpcom/base/nsIConsoleService.idl \
-	xpcom/base/nsIConsoleListener.idl \
 	xpcom/base/nsIErrorService.idl \
 	xpcom/base/nsIException.idl \
Index: trunk/src/libs/xpcom18a4/Makefile.kmk
===================================================================
--- trunk/src/libs/xpcom18a4/Makefile.kmk	(revision 101919)
+++ trunk/src/libs/xpcom18a4/Makefile.kmk	(revision 101920)
@@ -554,6 +554,4 @@
 VBox-xpcom-base_DEFS = _IMPL_NS_COM
 VBox-xpcom-base_SOURCES = \
-	xpcom/base/nsConsoleMessage.cpp \
-	xpcom/base/nsConsoleService.cpp \
 	xpcom/base/nsDebugImpl.cpp \
 	xpcom/base/nsErrorService.cpp \
@@ -1081,7 +1079,4 @@
 INSTALLS += VBoxXPCOMBase-xpt-inst
 VBOX_XPTFILES = $(addprefix $(PATH_TARGET)/VBox-xpcom-xpt-files/, \
-		nsIConsoleListener.xpt \
-		nsIConsoleMessage.xpt \
-		nsIConsoleService.xpt \
 		nsIErrorService.xpt \
 		nsIException.xpt \
Index: trunk/src/libs/xpcom18a4/xpcom/base/nsConsoleMessage.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/base/nsConsoleMessage.cpp	(revision 101919)
+++ 	(revision )
@@ -1,69 +1,0 @@
-/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is mozilla.org code.
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either of the GNU General Public License Version 2 or later (the "GPL"),
- * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-/*
- * Base implementation for console messages.
- */
-
-#include "nsConsoleMessage.h"
-#include "nsReadableUtils.h"
-
-NS_IMPL_THREADSAFE_ISUPPORTS1(nsConsoleMessage, nsIConsoleMessage)
-
-nsConsoleMessage::nsConsoleMessage() 
-{
-}
-
-nsConsoleMessage::nsConsoleMessage(const PRUnichar *message) 
-{
-	mMessage.Assign(message);
-}
-
-NS_IMETHODIMP
-nsConsoleMessage::GetMessage(PRUnichar **result) {
-    *result = ToNewUnicode(mMessage);
-
-    return NS_OK;
-}
-
-//  NS_IMETHODIMP
-//  nsConsoleMessage::Init(const PRUnichar *message) {
-//      nsAutoString newMessage(message);
-//      mMessage = ToNewUnicode(newMessage);
-//      return NS_OK;
-//  }
-
Index: trunk/src/libs/xpcom18a4/xpcom/base/nsConsoleMessage.h
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/base/nsConsoleMessage.h	(revision 101919)
+++ 	(revision )
@@ -1,58 +1,0 @@
-/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is mozilla.org code.
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either of the GNU General Public License Version 2 or later (the "GPL"),
- * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-#ifndef __nsconsolemessage_h__
-#define __nsconsolemessage_h__
-
-#include "nsIConsoleMessage.h"
-#include "nsString.h"
-
-class nsConsoleMessage : public nsIConsoleMessage {
-public:
-    nsConsoleMessage();
-    nsConsoleMessage(const PRUnichar *message);
-
-    NS_DECL_ISUPPORTS
-    NS_DECL_NSICONSOLEMESSAGE
-
-private:
-    ~nsConsoleMessage() {}
-
-    nsString mMessage;
-};
-
-#endif /* __nsconsolemessage_h__ */
Index: trunk/src/libs/xpcom18a4/xpcom/base/nsConsoleService.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/base/nsConsoleService.cpp	(revision 101919)
+++ 	(revision )
@@ -1,321 +1,0 @@
-/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is mozilla.org code.
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either of the GNU General Public License Version 2 or later (the "GPL"),
- * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-/*
- * Maintains a circular buffer of recent messages, and notifies
- * listeners when new messages are logged.
- */
-
-/* Threadsafe. */
-
-#include "nsMemory.h"
-#include "nsIServiceManager.h"
-#include "nsIProxyObjectManager.h"
-#include "nsSupportsArray.h"
-
-#include "nsConsoleService.h"
-#include "nsConsoleMessage.h"
-
-NS_IMPL_THREADSAFE_ISUPPORTS1(nsConsoleService, nsIConsoleService)
-
-nsConsoleService::nsConsoleService()
-    : mCurrent(0), mFull(PR_FALSE), mListening(PR_FALSE), mLock(nsnull)
-{
-    // XXX grab this from a pref!
-    // hm, but worry about circularity, bc we want to be able to report
-    // prefs errs...
-    mBufferSize = 250;
-
-    // XXX deal with these two allocations by detecting null mLock in factory?
-    mMessages = (nsIConsoleMessage **)
-        nsMemory::Alloc(mBufferSize * sizeof(nsIConsoleMessage *));
-
-    mLock = PR_NewLock();
-
-    // Array elements should be 0 initially for circular buffer algorithm.
-    for (PRUint32 i = 0; i < mBufferSize; i++) {
-        mMessages[i] = nsnull;
-    }
-
-}
-
-nsConsoleService::~nsConsoleService()
-{
-    PRUint32 i = 0;
-    while (i < mBufferSize && mMessages[i] != nsnull) {
-        NS_RELEASE(mMessages[i]);
-        i++;
-    }
-
-#ifdef DEBUG_mccabe
-    if (mListeners.Count() != 0) {
-        fprintf(stderr, 
-            "WARNING - %d console error listeners still registered!\n"
-            "More calls to nsIConsoleService::UnregisterListener needed.\n",
-            mListeners.Count());
-    }
-    
-#endif
-
-    nsMemory::Free(mMessages);
-    if (mLock)
-        PR_DestroyLock(mLock);
-}
-
-static PRBool PR_CALLBACK snapshot_enum_func(nsHashKey *key, void *data, void* closure)
-{
-    nsISupportsArray *array = (nsISupportsArray *)closure;
-
-    // Copy each element into the temporary nsSupportsArray...
-    array->AppendElement((nsISupports*)data);
-    return PR_TRUE;
-}
-
-// nsIConsoleService methods
-NS_IMETHODIMP
-nsConsoleService::LogMessage(nsIConsoleMessage *message)
-{
-    if (message == nsnull)
-        return NS_ERROR_INVALID_ARG;
-
-    nsSupportsArray listenersSnapshot;
-    nsIConsoleMessage *retiredMessage;
-
-    NS_ADDREF(message); // early, in case it's same as replaced below.
-
-    /*
-     * Lock while updating buffer, and while taking snapshot of
-     * listeners array.
-     */
-    {
-        nsAutoLock lock(mLock);
-
-        /*
-         * If there's already a message in the slot we're about to replace,
-         * we've wrapped around, and we need to release the old message.  We
-         * save a pointer to it, so we can release below outside the lock.
-         */
-        retiredMessage = mMessages[mCurrent];
-        
-        mMessages[mCurrent++] = message;
-        if (mCurrent == mBufferSize) {
-            mCurrent = 0; // wrap around.
-            mFull = PR_TRUE;
-        }
-
-        /*
-         * Copy the listeners into the snapshot array - in case a listener
-         * is removed during an Observe(...) notification...
-         */
-        mListeners.Enumerate(snapshot_enum_func, &listenersSnapshot);
-    }
-    if (retiredMessage != nsnull)
-        NS_RELEASE(retiredMessage);
-
-    /*
-     * Iterate through any registered listeners and tell them about
-     * the message.  We use the mListening flag to guard against
-     * recursive message logs.  This could sometimes result in
-     * listeners being skipped because of activity on other threads,
-     * when we only care about the recursive case.
-     */
-    nsCOMPtr<nsIConsoleListener> listener;
-    nsresult rv;
-    nsresult returned_rv;
-    PRUint32 snapshotCount;
-    rv = listenersSnapshot.Count(&snapshotCount);
-    if (NS_FAILED(rv))
-        return rv;
-
-    {
-        nsAutoLock lock(mLock);
-        if (mListening)
-            return NS_OK;
-        mListening = PR_TRUE;
-    }
-
-    returned_rv = NS_OK;
-    for (PRUint32 i = 0; i < snapshotCount; i++) {
-        rv = listenersSnapshot.GetElementAt(i, getter_AddRefs(listener));
-        if (NS_FAILED(rv)) {
-            returned_rv = rv;
-            break; // fall thru to mListening restore code below.
-        }
-        listener->Observe(message);
-    }
-    
-    {
-        nsAutoLock lock(mLock);
-        mListening = PR_FALSE;
-    }
-
-    return returned_rv;
-}
-
-NS_IMETHODIMP
-nsConsoleService::LogStringMessage(const PRUnichar *message)
-{
-    nsConsoleMessage *msg = new nsConsoleMessage(message);
-    return this->LogMessage(msg);
-}
-
-NS_IMETHODIMP
-nsConsoleService::GetMessageArray(nsIConsoleMessage ***messages, PRUint32 *count)
-{
-    nsIConsoleMessage **messageArray;
-
-    /*
-     * Lock the whole method, as we don't want anyone mucking with mCurrent or
-     * mFull while we're copying out the buffer.
-     */
-    nsAutoLock lock(mLock);
-
-    if (mCurrent == 0 && !mFull) {
-        /*
-         * Make a 1-length output array so that nobody gets confused,
-         * and return a count of 0.  This should result in a 0-length
-         * array object when called from script.
-         */
-        messageArray = (nsIConsoleMessage **)
-            nsMemory::Alloc(sizeof (nsIConsoleMessage *));
-        *messageArray = nsnull;
-        *messages = messageArray;
-        *count = 0;
-        
-        return NS_OK;
-    }
-
-    PRUint32 resultSize = mFull ? mBufferSize : mCurrent;
-    messageArray =
-        (nsIConsoleMessage **)nsMemory::Alloc((sizeof (nsIConsoleMessage *))
-                                              * resultSize);
-
-    if (messageArray == nsnull) {
-        *messages = nsnull;
-        *count = 0;
-        return NS_ERROR_FAILURE;
-    }
-
-    PRUint32 i;
-    if (mFull) {
-        for (i = 0; i < mBufferSize; i++) {
-            // if full, fill the buffer starting from mCurrent (which'll be
-            // oldest) wrapping around the buffer to the most recent.
-            messageArray[i] = mMessages[(mCurrent + i) % mBufferSize];
-            NS_ADDREF(messageArray[i]);
-        }
-    } else {
-        for (i = 0; i < mCurrent; i++) {
-            messageArray[i] = mMessages[i];
-            NS_ADDREF(messageArray[i]);
-        }
-    }
-    *count = resultSize;
-    *messages = messageArray;
-
-    return NS_OK;
-}
-
-NS_IMETHODIMP
-nsConsoleService::RegisterListener(nsIConsoleListener *listener) {
-    nsresult rv;
-
-    /*
-     * Store a threadsafe proxy to the listener rather than the
-     * listener itself; we want the console service to be callable
-     * from any thread, but listeners can be implemented in
-     * thread-specific ways, and we always want to call them on their
-     * originating thread.  JavaScript is the motivating example.
-     */
-    nsCOMPtr<nsIConsoleListener> proxiedListener;
-
-    rv = GetProxyForListener(listener, getter_AddRefs(proxiedListener));
-    if (NS_FAILED(rv))
-        return rv;
-
-    {
-        nsAutoLock lock(mLock);
-        nsISupportsKey key(listener);
-
-        /*
-         * Put the proxy event listener into a hashtable using the *real* 
-         * listener as the key.
-         *
-         * This is necessary because proxy objects do *not* maintain
-         * nsISupports identity.  Therefore, since GetProxyForListener(...)
-         * can return different proxies for the same object (see bug #85831)
-         * we need to use the real object as the unique key...
-         */
-        mListeners.Put(&key, proxiedListener);
-    }
-    return NS_OK;
-}
-
-NS_IMETHODIMP
-nsConsoleService::UnregisterListener(nsIConsoleListener *listener) {
-    nsAutoLock lock(mLock);
-
-    nsISupportsKey key(listener);
-    mListeners.Remove(&key);
-    return NS_OK;
-}
-
-nsresult 
-nsConsoleService::GetProxyForListener(nsIConsoleListener* aListener,
-                                      nsIConsoleListener** aProxy)
-{
-    nsresult rv;
-    *aProxy = nsnull;
-
-    nsCOMPtr<nsIProxyObjectManager> proxyManager =
-        (do_GetService(NS_XPCOMPROXY_CONTRACTID));
-
-    if (proxyManager == nsnull)
-        return NS_ERROR_NOT_AVAILABLE;
-
-    /*
-     * NOTE this will fail if the calling thread doesn't have an eventQ.
-     *
-     * Would it be better to catch that case and leave the listener unproxied?
-     */
-    rv = proxyManager->GetProxyForObject(NS_CURRENT_EVENTQ,
-                                         NS_GET_IID(nsIConsoleListener),
-                                         aListener,
-                                         PROXY_ASYNC | PROXY_ALWAYS,
-                                         (void**) aProxy);
-    return rv;
-}
Index: trunk/src/libs/xpcom18a4/xpcom/base/nsConsoleService.h
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/base/nsConsoleService.h	(revision 101919)
+++ 	(revision )
@@ -1,89 +1,0 @@
-/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is mozilla.org code.
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either of the GNU General Public License Version 2 or later (the "GPL"),
- * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-/*
- * nsConsoleService class declaration.
- */
-
-#ifndef __nsconsoleservice_h__
-#define __nsconsoleservice_h__
-
-#include "nsCOMPtr.h"
-#include "nsHashtable.h"
-#include "nsAutoLock.h"
-
-#include "nsIConsoleService.h"
-
-class nsConsoleService : public nsIConsoleService
-{
-public:
-    nsConsoleService();
-
-    NS_DECL_ISUPPORTS
-    NS_DECL_NSICONSOLESERVICE
-
-private:
-    ~nsConsoleService();
-
-    // build (or find) a proxy for the listener
-    nsresult GetProxyForListener(nsIConsoleListener* aListener,
-                                 nsIConsoleListener** aProxy);
-
-    // Circular buffer of saved messages
-    nsIConsoleMessage **mMessages;
-
-    // How big?
-    PRUint32 mBufferSize;
-
-    // Index of slot in mMessages that'll be filled by *next* log message
-    PRUint32 mCurrent;
-
-    // Is the buffer full? (Has mCurrent wrapped around at least once?)
-    PRBool mFull;
-
-    // Listeners to notify whenever a new message is logged.
-    nsSupportsHashtable mListeners;
-
-    // Current listener being notified of a logged error - to prevent
-    // stack overflows.
-    PRBool mListening;
-
-    // To serialize interesting methods.
-    PRLock *mLock;
-};
-
-#endif /* __nsconsoleservice_h__ */
Index: trunk/src/libs/xpcom18a4/xpcom/base/nsIConsoleListener.idl
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/base/nsIConsoleListener.idl	(revision 101919)
+++ 	(revision )
@@ -1,49 +1,0 @@
-/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is mozilla.org code.
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either of the GNU General Public License Version 2 or later (the "GPL"),
- * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-/*
- * Used by the console service to notify listeners of new console messages.
- */
-
-#include "nsISupports.idl"
-#include "nsIConsoleMessage.idl"
-
-[scriptable, uuid(eaaf61d6-1dd1-11b2-bc6e-8fc96480f20d)]
-interface nsIConsoleListener : nsISupports
-{
-    void observe(in nsIConsoleMessage aMessage);
-};
Index: trunk/src/libs/xpcom18a4/xpcom/base/nsIConsoleMessage.idl
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/base/nsIConsoleMessage.idl	(revision 101919)
+++ 	(revision )
@@ -1,56 +1,0 @@
-/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is mozilla.org code.
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either of the GNU General Public License Version 2 or later (the "GPL"),
- * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-#include "nsISupports.idl"
-
-/**
- * This is intended as a base interface; implementations may want to
- * provide an object that can be qi'ed to provide more specific
- * message information.
- */
-[scriptable, uuid(41bd8784-1dd2-11b2-9553-8606958fffe1)]
-interface nsIConsoleMessage : nsISupports
-{
-    readonly attribute wstring message;
-};
-
-%{ C++
-#define NS_CONSOLEMESSAGE_CID \
-{ 0x56c9d666, 0x1dd2, 0x11b2, { 0xb4, 0x3c, 0xa8, 0x4b, 0xf3, 0xb3, 0xec, 0xbb }}
-
-#define NS_CONSOLEMESSAGE_CONTRACTID "@mozilla.org/consolemessage;1"
-%}
Index: trunk/src/libs/xpcom18a4/xpcom/base/nsIConsoleService.idl
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/base/nsIConsoleService.idl	(revision 101919)
+++ 	(revision )
@@ -1,85 +1,0 @@
-/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is mozilla.org code.
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either of the GNU General Public License Version 2 or later (the "GPL"),
- * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-#include "nsISupports.idl"
-#include "nsIConsoleListener.idl"
-#include "nsIConsoleMessage.idl"
-
-[scriptable, uuid(a647f184-1dd1-11b2-a9d1-8537b201161b)]
-interface nsIConsoleService : nsISupports
-{
-    void logMessage(in nsIConsoleMessage message);
-
-    /**
-     * Convenience method for logging simple messages.
-     */
-    void logStringMessage(in wstring message);
-
-    /**
-     * Get an array of all the messages logged so far.  If no messages
-     * are logged, this function will return a count of 0, but still
-     * will allocate one word for messages, so as to show up as a
-     * 0-length array when called from script.
-     */
-    void getMessageArray([array, size_is(count)] out nsIConsoleMessage messages,
-                         out PRUint32 count);
-
-    /**
-     * To guard against stack overflows from listeners that could log
-     * messages (it's easy to do this inadvertently from listeners
-     * implemented in JavaScript), we don't call any listeners when
-     * another error is already being logged.
-     */
-    void registerListener(in nsIConsoleListener listener);
-
-    /**
-     * Each registered listener should also be unregistered.
-     */
-    void unregisterListener(in nsIConsoleListener listener);
-   
-};
-
-
-%{ C++
-#define NS_CONSOLESERVICE_CLASSNAME "Console Service"
-
-#define NS_CONSOLESERVICE_CID \
-{ 0x7e3ff85c, 0x1dd2, 0x11b2, { 0x8d, 0x4b, 0xeb, 0x45, 0x2c, 0xb0, 0xff, 0x40 }}
-
-#define NS_CONSOLESERVICE_CONTRACTID "@mozilla.org/consoleservice;1"
-%}
-
Index: trunk/src/libs/xpcom18a4/xpcom/build/nsXPComInit.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/build/nsXPComInit.cpp	(revision 101919)
+++ trunk/src/libs/xpcom18a4/xpcom/build/nsXPComInit.cpp	(revision 101920)
@@ -55,5 +55,4 @@
 #include "nsArray.h"
 #include "nsSupportsPrimitives.h"
-#include "nsConsoleService.h"
 #include "nsExceptionService.h"
 
@@ -163,5 +162,4 @@
 
 NS_GENERIC_FACTORY_CONSTRUCTOR(nsArray)
-NS_GENERIC_FACTORY_CONSTRUCTOR(nsConsoleService)
 NS_GENERIC_FACTORY_CONSTRUCTOR(nsAtomService)
 NS_GENERIC_FACTORY_CONSTRUCTOR(nsExceptionService)
@@ -332,5 +330,4 @@
     COMPONENT(SUPPORTSARRAY, nsSupportsArray::Create),
     COMPONENT(ARRAY, nsArrayConstructor),
-    COMPONENT(CONSOLESERVICE, nsConsoleServiceConstructor),
     COMPONENT(EXCEPTIONSERVICE, nsExceptionServiceConstructor),
     COMPONENT(ATOMSERVICE, nsAtomServiceConstructor),