Index: trunk/src/libs/xpcom18a4/nsprpub/pr/include/prio.h
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/include/prio.h	(revision 101934)
+++ trunk/src/libs/xpcom18a4/nsprpub/pr/include/prio.h	(revision 101935)
@@ -72,7 +72,4 @@
 #define PR_Listen VBoxNsprPR_Listen
 #define PR_Accept VBoxNsprPR_Accept
-#define PR_OpenDir VBoxNsprPR_OpenDir
-#define PR_ReadDir VBoxNsprPR_ReadDir
-#define PR_CloseDir VBoxNsprPR_CloseDir
 #define PR_CreatePipe VBoxNsprPR_CreatePipe
 #define PR_GetDescType VBoxNsprPR_GetDescType
@@ -962,88 +959,4 @@
 NSPR_API(PRStatus)	PR_Sync(PRFileDesc *fd);
 
-/************************************************************************/
-
-struct PRDirEntry {
-    const char *name;        /* name of entry, relative to directory name */
-};
-
-#if !defined(NO_NSPR_10_SUPPORT)
-#define PR_DirName(dirEntry)	(dirEntry->name)
-#endif
-
-/*
- *************************************************************************
- * FUNCTION: PR_OpenDir
- * DESCRIPTION:
- *     Open the directory by the given name
- * INPUTS:
- *     const char *name
- *         path name of the directory to be opened
- * OUTPUTS:
- *     None
- * RETURN: PRDir *
- *     If the directory is sucessfully opened, a PRDir object is
- *     dynamically allocated and a pointer to it is returned.
- *     If the directory cannot be opened, a NULL pointer is returned.
- * MEMORY:
- *     Upon successful completion, the return value points to
- *     dynamically allocated memory.
- *************************************************************************
- */
-
-NSPR_API(PRDir*) PR_OpenDir(const char *name);
-
-/*
- *************************************************************************
- * FUNCTION: PR_ReadDir
- * DESCRIPTION:
- * INPUTS:
- *     PRDir *dir
- *         pointer to a PRDir object that designates an open directory
- *     PRDirFlags flags
- *           PR_SKIP_NONE     Do not skip any files
- *           PR_SKIP_DOT      Skip the directory entry "." that
- *                            represents the current directory
- *           PR_SKIP_DOT_DOT  Skip the directory entry ".." that
- *                            represents the parent directory.
- *           PR_SKIP_BOTH     Skip both '.' and '..'
- *           PR_SKIP_HIDDEN   Skip hidden files
- * OUTPUTS:
- * RETURN: PRDirEntry*
- *     Returns a pointer to the next entry in the directory.  Returns
- *     a NULL pointer upon reaching the end of the directory or when an
- *     error occurs. The actual reason can be retrieved via PR_GetError().
- *************************************************************************
- */
-
-typedef enum PRDirFlags {
-    PR_SKIP_NONE = 0x0,
-    PR_SKIP_DOT = 0x1,
-    PR_SKIP_DOT_DOT = 0x2,
-    PR_SKIP_BOTH = 0x3,
-    PR_SKIP_HIDDEN = 0x4
-} PRDirFlags;
-
-NSPR_API(PRDirEntry*) PR_ReadDir(PRDir *dir, PRDirFlags flags);
-
-/*
- *************************************************************************
- * FUNCTION: PR_CloseDir
- * DESCRIPTION:
- *     Close the specified directory.
- * INPUTS:
- *     PRDir *dir
- *        The directory to be closed.
- * OUTPUTS:
- *     None
- * RETURN: PRStatus
- *        If successful, will return a status of PR_SUCCESS. Otherwise
- *        a value of PR_FAILURE. The reason for the failure may be re-
- *        trieved using PR_GetError().
- *************************************************************************
- */
-
-NSPR_API(PRStatus) PR_CloseDir(PRDir *dir);
-
 /*
  *************************************************************************
Index: trunk/src/libs/xpcom18a4/nsprpub/pr/include/private/primpl.h
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/include/private/primpl.h	(revision 101934)
+++ trunk/src/libs/xpcom18a4/nsprpub/pr/include/private/primpl.h	(revision 101935)
@@ -499,9 +499,4 @@
                          * the address family of the socket. */
 #endif
-};
-
-struct PRDir {
-    PRDirEntry d;
-    _MDDir md;
 };
 
Index: trunk/src/libs/xpcom18a4/nsprpub/pr/src/pthreads/ptio.c
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/src/pthreads/ptio.c	(revision 101934)
+++ trunk/src/libs/xpcom18a4/nsprpub/pr/src/pthreads/ptio.c	(revision 101935)
@@ -2099,39 +2099,4 @@
     return (0 == rv) ? PR_SUCCESS : PR_FAILURE;
 }  /* PR_GetFileInfo64 */
-
-PR_IMPLEMENT(PRStatus) PR_CloseDir(PRDir *dir)
-{
-    if (pt_TestAbort()) return PR_FAILURE;
-
-    if (NULL != dir->md.d)
-    {
-        if (closedir(dir->md.d) == -1)
-        {
-            _PR_MD_MAP_CLOSEDIR_ERROR(errno);
-            return PR_FAILURE;
-        }
-        dir->md.d = NULL;
-        PR_DELETE(dir);
-    }
-    return PR_SUCCESS;
-}  /* PR_CloseDir */
-
-PR_IMPLEMENT(PRDir*) PR_OpenDir(const char *name)
-{
-    DIR *osdir;
-    PRDir *dir = NULL;
-
-    if (pt_TestAbort()) return dir;
-
-    osdir = opendir(name);
-    if (osdir == NULL)
-        pt_MapError(_PR_MD_MAP_OPENDIR_ERROR, errno);
-    else
-    {
-        dir = PR_NEWZAP(PRDir);
-        dir->md.d = osdir;
-    }
-    return dir;
-}  /* PR_OpenDir */
 
 static PRInt32 _pr_poll_with_poll(
@@ -2388,29 +2353,4 @@
 }
 
-PR_IMPLEMENT(PRDirEntry*) PR_ReadDir(PRDir *dir, PRDirFlags flags)
-{
-    struct dirent *dp;
-
-    if (pt_TestAbort()) return NULL;
-
-    for (;;)
-    {
-        dp = readdir(dir->md.d);
-        if (NULL == dp) return NULL;
-        if ((flags & PR_SKIP_DOT)
-            && ('.' == dp->d_name[0])
-            && (0 == dp->d_name[1])) continue;
-        if ((flags & PR_SKIP_DOT_DOT)
-            && ('.' == dp->d_name[0])
-            && ('.' == dp->d_name[1])
-            && (0 == dp->d_name[2])) continue;
-        if ((flags & PR_SKIP_HIDDEN) && ('.' == dp->d_name[0]))
-            continue;
-        break;
-    }
-    dir->d.name = dp->d_name;
-    return &dir->d;
-}  /* PR_ReadDir */
-
 PR_IMPLEMENT(PRFileDesc*) PR_OpenTCPSocket(PRIntn af)
 {